/***** stringUtil.h **********************************************
 * Description:  Header file for string utilities.
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * File created on Sun Jun  6 00:23:34 2004.
 ****************************************************************/
#ifndef STRINGUTIL
#define STRINGUTIL

#define HASHSIZE 101  /* size of hash table */ 
#define MAXFIELDS 5000 /* maximum number of fields */

typedef struct wordNode{    /* node in a word tree */
    char *word;             /* word to be counted */
    int count;              /* number of occurrences */
    struct wordNode *left;  /* left child */
    struct wordNode *right; /* right child */
} WordNode;


char *chomp(char *line);
char *cleanWord(char *word);
char *cleanWordEdges(char *word);
unsigned hash(char *s);
char *strdup2(char *s);
void split(char *line, char *splitC, char **splitArray, int *arrayLen);
char *strtolower(char *s);
void itoa (int n, char *s);
void reverse(char *s);
void printWrap(FILE *fp, char *line, int l);

WordNode *addWord(WordNode *p, char *w);
WordNode *walloc(void);
void treeprint(WordNode *p);
void itoa(int n, char s[]);
#endif
